/*
=====================================================
檔案名稱：ozio 様 js 共通ファイル
檔案用途：カスタマイズのjs、タグなどは既にここに書いてある
檔案建立日：2017.10.27
檔案建立人：Bella.Wu

＊＊ps.增加或修改請一定要備註寫清楚做何用途，感謝＊＊
=====================================================
*/
var $ = jQuery;
jQuery(function ($) {
  var time = new Date().getTime();
  var API_script_LINK = 'https://www.cros.tw/lp/development/LP_API/API.js?time' + time;
  var API_script_TAG = $('<script>').prop('src', API_script_LINK);
  $('head').append(API_script_TAG);
});
window.addEventListener("load", function () {
  AddMemo();
  AddArrivedDateMemo();
  AddShippingMemo();
  // addMomo1();
  // addMemoGENLP2tka();
});
window.addEventListener('load', function () {
  addPolicy();
  if (window.location.pathname == '/venus/lp03/') {
    addPolicy2()
  }

  if (window.location.pathname == '/Midsell2019/' ||
    window.location.pathname == '/Midsell2019_f1/' ||
    window.location.pathname == '/Midsell2019_f2f/') {
    addBlueText();
  }
  if (window.location.pathname == '/ubjmidsell2019/') {
    addBlueText2();
  }
  if (window.location.pathname == '/Midsell2019A/' ||
    window.location.pathname == '/anualsell2019/') {
    addBlueText3();
    var timer = setInterval(function () {
      if (jQuery('#productCode').length > 0) {
        selectProductWithParamsObj(getAllUrlParams());
        clearInterval(timer);
      }
    }, 1000);
  }
  if (window.location.pathname == '/qqnewyearsell/') {
    addRedText();
  }
  if (window.location.pathname == '/newyearsell/') {
    addRedText2();
  }
  if (window.location.pathname == '/BD02/') {
    addBirthdayMemo();
  }
});
//window.addEventListener('load', function() { addMomo1(); });

/* ----------------------------------------------- 共通ポリシーテキスト ----------------------------------------------- */
// var policyText = "<退貨規定>\n\
// 以上內容若確認且按下訂購鍵將視為同意。";
var policyText = "\
 對於購買所需填寫的個人資料，本公司將遵守個人資料保護相關法令規定，完成購買即表示同意本公司依個人資料保護相關法令處理、利用你的個人資料。\n\
 為了完成交易，包括且不限於完成付款及交付等，你必須擔保在訂購過程中所留存的所有資料均為完整、正確、與當時情況相符的資料，如果事後有變更，你應該即時通知本公司客服人員。\n\
 對於你所留存的資料，本公司除了採用安全交易模式外，並承諾負擔保密義務，除了為完成交易、提供顧客服務或在符合相關法令之規範下而提供給相關商品或服務之配合廠商以外，不會任意洩漏或提供給第三人。\n\
 為了完成交易與提供服務(包含商品、發票或贈品之運送以及服務滿意度調查)，本公司需將你的個人資訊提供給運送服務廠商及服務滿意度調查廠商，並由廠商與你聯繫安排商品之運送與服務滿意度調查；你的個人資訊包含姓名\
、地址、電話等，也可能因運送之需求而需要揭露於商品之外包裝上。";

var policyText2 = "\
※商品退換貨說明※\n\
・依照消費者保護法規定，商品到貨後，如有破損或是與商品內容物不符而有退換貨之必要時，請於七天內與客服聯絡。\n\
請務必詳閱商品說明並再次確認確有購買該項商品之需求及意願時始下單購買，有任何疑問並請先聯繫本公司客服詢問。\n\
　客服電話：0809-091-686\n\
　營業時間：09:00~21:00 全年無休\n\
\n\
・若需退貨，請務必連同統一發票及商品寄回方可辦理退貨服務。於收到商品後，會立即為您辦理。\n\
\n\
※個人資料暨隱私權保護政策聲明※\n\
・對於購買所需填寫的個人資料，本公司將遵守個人資料保護相關法令規定，完成購買即表示同意本公司依個人資料保護相關法令處理、利用你的個人資料。\n\
・為了完成交易，包括且不限於完成付款及交付等，你必須擔保在訂購過程中所留存的所有資料均為完整、正確、與當時情況相符的資料，如果事後有變更，你應該即時通知本公司客服人員。\n\
・對於你所留存的資料，本公司除了採用安全交易模式外，並承諾負擔保密義務，除了為完成交易、提供顧客服務或在符合相關法令之規範下而提供給相關商品或服務之配合廠商以外，不會任意洩漏或提供給第三人。\n\
・為了完成交易與提供服務(包含商品、發票或贈品之運送以及服務滿意度調查)，本公司需將你的個人資訊提供給運送服務廠商及服務滿意度調查廠商，並由廠商與你聯繫安排商品之運送與服務滿意度調查；你的個人資訊包含姓名、地址、電話等，也可能因運送之需求而需要揭露於商品之外包裝上。\n\
\n\
以上內容若確認且按下訂購鍵將視為同意";
/* ----------------------------------------------- 共通ポリシーテキスト ----------------------------------------------- */

/*----------------------------------------------function-----------------------------------------*/
//window.onload=function(){
function addPolicy() {
  if (document.getElementById("policy") == null) {
    setTimeout(addPolicy, 1000);
    return;
  }
  policyTitle = document.getElementById("policyTitle");
  policyTitle.innerText = "※個人資料暨隱私權保護政策聲明※";

  policyContact = document.getElementById("policyText");
  policyContact.innerHTML = policyText;
  policyContact.style.display = "";

  //br   = document.createElement('br');
  //document.getElementById('submitBtn').appendChild(label);
  //document.getElementById('submitBtn').appendChild(text);
}

function addPolicy2() {
  if (document.getElementById("policy") == null) {
    setTimeout(addPolicy2, 1000);
    return;
  }
  policyTitle = document.getElementById("policyTitle");
  policyTitle.innerText = "※個人資料暨隱私權保護政策聲明※";

  policyContact = document.getElementById("policyText");
  policyContact.innerHTML = policyText2;
  policyContact.style.display = "";

  //br   = document.createElement('br');
  //document.getElementById('submitBtn').appendChild(label);
  //document.getElementById('submitBtn').appendChild(text);
}

function addBirthdayMemo() {
  if (document.querySelector('#tr_timeId') == null) {
    setTimeout(addBirthdayMemo, 1000);
    return;
  } else {
    const memoUnderTimelot = document.createElement('div');
    memoUnderTimelot.id = 'newYearMemoInTimelot';
    memoUnderTimelot.style = 'color: red;';
    memoUnderTimelot.innerHTML = '歐姬兒生日活動商品受好評熱銷。商品由2/12開始配送，造成不便，敬請見諒。';
    if (document.querySelector('#tr_timeId .rightContents').lastElementChild.id != 'newYearMemoInTimelot') {
      document.querySelector('#tr_timeId .rightContents').append(memoUnderTimelot)
    }
  }
}

function AddMemo() {
  jQuery(function ($) {
    if (document.getElementsByClassName("titlefontdk5") == null) {
      setTimeout(AddMemo, 1000);
      return;
    }
    jQuery(".titlefontdk5").html("1)「農曆新年前两周至農曆新年期間」、「端午節、中秋節前一周」及「雙11購物節後一至两周」為物流高峯期, 故無法指定配送時段敬請見諒。" +
      "<br>2)另如遇颱風地震等天災、公共工程、節慶活動管制路段, 出貨時間將順延。 實際送達時間, 以物流公司嘅出貨日, 送貨路線及貨量為主。<br>3) 宅配件至發貨日至 2/1号 (五) 止。<br>" +
      "(為避免宅配件派送時效受節日影響, 建議訂單都於 1/31 (四) 號先發貨完畢)<br>" + "外務員最後配送日為 2/2 (六), 若因不可抗因素無法派件完成則將於 2/11 (一) 再進行派件 <br>" + "承上, 貨件若滯留營業站所可接受自取, 請 1. 入線0800同客服確認貨件係咪滯留企所.約定自取時間自行取貨 P.S 除夕下午唔接受自取");
  });
}

function AddShippingMemo() {
  if (document.getElementById('shippingDate') == null) {
    setTimeout(AddShippingMemo, 1000);
  } else {
    if (document.querySelector('#shippingDate').nextSibling.id != 'shippingMemo_34260') {
      let shippingMemo_34260 = document.createElement('span');
      shippingMemo_34260.style = 'color:red; font-weight:bolder';
      shippingMemo_34260.id = 'shippingMemo_34260';
      shippingMemo_34260.innerText = '實際到貨時間依物流公司配送時間為主'

      document.querySelector('#shippingDate').after(shippingMemo_34260)
    }
  }
}

function AddArrivedDateMemo() {
  if (document.getElementById('tr_timeslot') == null) {
    setTimeout(AddArrivedDateMemo, 1000);
  } else {
    if (location.pathname == '/anualsell2019/' ||
      location.pathname == '/white/lp02/') {
      let memo = document.createElement('div');
      memo.style = 'color:red;';
      memo.innerHTML = '感謝好評熱售廠商加速補貨中，<br>最快出貨日為11月25日敬請見諒。';
      // document.getElementById('tr_timeslot').append(memo);
    } else if (location.pathname == '/SE09/') {
      let memo = document.createElement('div');
      memo.style = 'color:red;';
      memo.innerHTML = '由於商品熱賣，目前的商品從12月17日開始配送，造成您的不便，非常抱歉';
      document.getElementById('tr_timeslot').append(memo);
    } else if (location.pathname == '/white/christmas/' || location.pathname == '/christmas/') {
      let memo = document.createElement('div');
      memo.style = 'color:red;';
      memo.innerHTML = '因好評熱售影響，發送所需時間較久，造成不便，敬請見諒';
      document.getElementById('tr_timeslot').append(memo);
    } else if (location.pathname == '/white/lp01/' || location.pathname == '/white/lp03wang/' ) {
      let memo = document.createElement('div');
      memo.style = 'color:red;';
      memo.innerHTML = '因好評熱銷影響，發送所需時間較久，造成不便，敬請見諒　';
      document.getElementById('tr_timeslot').append(memo);
    } 
  }
}

function addMomo1() {
  if (document.getElementById("tr_Memo1") == null) {
    setTimeout(addMomo1, 1000);
    return;
  }
}

/*
function: addBlueText(), blue_text()
function 用途: 販促コード：Midsell2019 之商品特殊藍字提醒
2019.07.16 add by Jack(Access)
*/
function addBlueText() {

  if (document.getElementById("priceCurrency") == null) {
    setTimeout(adPriceMomo, 500);
    return;
  }

  // 加入元素
  // jQuery("#priceCurrency").after('<br><span style="color: blue; padding-left: 10px; font-weight: bold; font-size:14px;" id="blue_text"></span>');

  // 圖片超連結點擊時觸發
  jQuery("a[href='#lp_form']").click(function () {
    blue_text();
  });

  // 購入商品切換時觸發
  jQuery("#productCode").change(function () {
    blue_text();
  });
}

function blue_text() {
  if (jQuery("#productCode").val() == 'rjm6-1n') {
    jQuery('#blue_text').remove();
    jQuery('#tr_price').append('<span style="color: blue; padding-left: 10px; font-weight: bold; font-size:14px;" id="blue_text"><br>歐姬兒蜂王乳凝露買五送一總共六瓶，再加送一瓶20g旅行隨身組。</span>');
  } else if (jQuery("#productCode").val() == 'rjm6-1n1OZ') {
    jQuery('#blue_text').remove();
    jQuery('#tr_price').append('<span style="color: blue; padding-left: 10px; font-weight: bold; font-size:14px;" id="blue_text"><br>歐姬兒蜂王乳凝露買6罐就打68折， 不僅送一瓶20g旅行隨身組！再加碼贈送一瓶日本狂銷的蜂蜜優格洗面乳 (原價1000) 。</span>');
  } else {
    jQuery('#blue_text').remove();
  }
}

/*
function: addBlueText2(), blue_text2()
function 用途: 販促コード：ubjmidsell2019 之商品特殊藍字提醒
2019.07.25 add by Jack(Access)
*/
function addBlueText2() {

  if (document.getElementById("priceCurrency") == null) {
    setTimeout(adPriceMomo, 500);
    return;
  }

  // 加入元素
  jQuery("#priceCurrency").after('<br><span style="color: blue; padding-left: 10px; font-weight: bold; font-size:14px;" id="blue_text"></span>');

  // 圖片超連結點擊時觸發
  jQuery("a[href='#lp_form']").click(function () {
    blue_text2();
  });

  // 購入商品切換時觸發
  jQuery("#productCode").change(function () {
    blue_text2();
  });
}

function blue_text2() {
  if (jQuery("#productCode").val() == 'ubj2-1n') {
    jQuery('#blue_text').text('歐姬兒熊果素淨白凝露買2瓶54折 ，只要10元再送1條20ml隨身保濕乳霜');
  } else if (jQuery("#productCode").val() == 'ubj3-1OZ1n') {
    jQuery('#blue_text').html(`【年中慶限定超優惠組】 購買歐姬兒熊果素淨白凝露3瓶 ， 不僅送20ml隨身保濕乳霜！ <br/>
    &nbsp;&nbsp;&nbsp;&nbsp;再加碼贈送日本狂銷的蜂蜜優格洗面乳 (市價1000)。`);
  } else {
    jQuery('#blue_text').text('');
  }
}

/*
function: addBlueText3(), blue_text3()
function 用途: 販促コード：Midsell2019A 之商品特殊藍字提醒
2019.08.08 add by Jack(Access)
*/
function addBlueText3() {

  if (document.getElementById("priceCurrency") == null) {
    setTimeout(addBlueText3, 500);
    return;
  }
  // 加入元素
  jQuery("#priceCurrency").after('<br><span style="color: blue; font-weight: bold; font-size:14px;" id="blue_text"></span>');

  // 圖片超連結點擊時觸發
  jQuery("a[href='#lp_form']").click(function () {
    blue_text3();
  });

  // 購入商品切換時觸發
  jQuery("#productCode").change(function () {
    blue_text3();
  });
}

function blue_text3() {
  if (jQuery("#productCode").val() == 'rjm6-1n') {
    jQuery('#blue_text').text('歐姬兒蜂王乳凝露買5送1總共6瓶，再加送一瓶20g旅行隨身組。');
  } else if (jQuery("#productCode").val() == 'rjm6-1n1OZ') {
    jQuery('#blue_text').html('歐姬兒蜂王乳凝露買6罐就打68折，不僅送一瓶20g旅行隨身組！<br/>再加碼贈送一瓶日本狂銷的蜂蜜優格洗面乳 (原價1000) 。');
  } else if (jQuery("#productCode").val() == 'rjm3') {
    jQuery('#blue_text').html('歐姬兒蜂王乳凝露x3 瓶');
  } else if (jQuery("#productCode").val() == 'rjm6-1Qnbb') {
    jQuery('#blue_text').html('蜂王乳凝露買五瓶就送日本爆紅蜂王乳QQ潤白凝露乙瓶(原價1690)，加碼再贈20g旅行隨身組和歐姬兒品牌提袋');
  } else {
    jQuery('#blue_text').text('');
  }
}

/*
function: addRedText(), red_text()
function 用途: #23810 之商品特殊紅字提醒
2019.12.30 add by Jack(Access)
*/
function addRedText() {

  if (document.getElementById("priceCurrency") == null) {
    setTimeout(addRedText, 500);
    return;
  }
  // 加入元素
  jQuery("#priceCurrency").after('<br><span style="color: red; font-weight: bold; font-size:14px; white-space: pre;" id="red_text"></span>');

  // 圖片超連結點擊時觸發
  jQuery("a[href='#lp_form']").click(function () {
    red_text();
  });

  // 購入商品切換時觸發
  jQuery("#productCode").change(function () {
    red_text();
  });
}

function red_text() {
  if (jQuery("#productCode").val() == 'wrjm4rjm1egg1' ||
    jQuery("#productCode").val() == 'wrjm4R1E1') {
    jQuery('#red_text').text(`蜂王乳QQ潤白凝露(罐)x 2\n蜂王乳QQ潤白凝露(條)x 2\n兩大新春好禮 (蜂王乳保濕凝露 +獨創新年限定美妝蛋)`);
  } else {
    jQuery('#red_text').text('');
  }
}

/*
function: addRedText2(), red_text2()
function 用途: #23811 之商品特殊紅字提醒
2019.12.30 add by Jack(Access)
*/
function addRedText2() {

  if (document.getElementById("priceCurrency") == null) {
    setTimeout(addRedText, 500);
    return;
  }
  // 加入元素
  jQuery("#priceCurrency").after('<br><span style="color: red; font-weight: bold; font-size:14px; white-space: pre;" id="red_text"></span>');

  // 圖片超連結點擊時觸發
  jQuery("a[href='#lp_form']").click(function () {
    red_text2();
  });

  // 購入商品切換時觸發
  jQuery("#productCode").change(function () {
    red_text2();
  });
}

function red_text2() {
  if (jQuery("#productCode").val() == 'rjm5S1B1egg1' ||
    jQuery("#productCode").val() == 'rjm5S1B1E1') {
    jQuery('#red_text').text(`【3大好禮】\n蜂蜜優格洗顏x1\n原創美妝蛋禮盒x1\n品牌手提袋x1`);
  } else {
    jQuery('#red_text').text('');
  }
}

//for redmine #15507 START
function getAllUrlParams(url) {

  var queryString = url ? url.split('?')[1] : window.location.search.slice(1);

  var obj = {};

  if (queryString) {

    queryString = queryString.split('#')[0];

    var arr = queryString.split('&');

    for (var i = 0; i < arr.length; i++) {
      var a = arr[i].split('=');

      var paramName = a[0];
      var paramValue = (Object.prototype.toString(a[1]) === '[object Undefined]') ? true : a[1];

      if (paramName.match(/\[(\d+)?\]$/)) {

        var key = paramName.replace(/\[(\d+)?\]/, '');
        if (!obj[key]) {
          obj[key] = [];
        }

        if (paramName.match(/\[\d+\]$/)) {
          var index = /\[(\d+)\]/.exec(paramName)[1];
          obj[key][index] = paramValue;
        } else {
          obj[key].push(paramValue);
        }
      } else {
        if (!obj[paramName]) {
          obj[paramName] = paramValue;
        } else if (obj[paramName] && (Object.prototype.toString(obj[paramName]) === '[object String]')) {
          obj[paramName] = [obj[paramName]];
          obj[paramName].push(paramValue);
        } else {
          obj[paramName].push(paramValue);
        }
      }
    }
  }

  return obj;
}

function selectProductWithParamsObj(paramsObj) {

  var getProductCode = function () {
    if (Object.prototype.toString.call(paramsObj) === '[object Object]') {
      for (var param in paramsObj) {
        // 抓指定參數
        if (param === 'select_product_code') {
          return {
            'select_product_code': paramsObj[param]
          };
        }
      }
      return {
        'select_product_code': ''
      };
    };
  }
  if (getProductCode().select_product_code !== '') {
    // console.log(getProductCode().select_product_code);
    // console.log(jQuery('#productCode option[value=' + getProductCode().select_product_code + ']').length);
    if (jQuery('#productCode option[value=' + getProductCode().select_product_code + ']').length) {
      jQuery('#productCode').val(getProductCode().select_product_code);
      jQuery('#productCode').trigger('change');
    } else {
      // console.log('商品編號或商品編號參數有錯誤!');
    }
  }
}
//for redmine #15507 END

/*----------------------------------------------function-----------------------------------------*/

/*----------------------------------------------タグ設置-----------------------------------------*/

/*
function Name:専用GTM(亞星通)
function 用途:Google Tag Manager
2017.10.27 add
*/
function callGTM() {
  // Google Tag Manager
  document.write(
    '<noscript><iframe src="//www.googletagmanager.com/ns.html?id=GTM-MMGGLB" \n\
		height="0" width="0" style="display:none;visibility:hidden"></iframe></noscript> \n\
		<script>(function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({"gtm.start":\n\
		new Date().getTime(),event:"gtm.js"});var f=d.getElementsByTagName(s)[0],\n\
		j=d.createElement(s),dl=l!="dataLayer"?"&l="+l:"";j.async=true;j.src= \n\
		"//www.googletagmanager.com/gtm.js?id="+i+dl;f.parentNode.insertBefore(j,f);\n\
		})(window,document,"script","dataLayer","GTM-MMGGLB");</script>'
  );
  // End Google Tag Manager
}

function callGTM2() {
  // Google Tag Manager
  document.write(
    '<noscript><iframe src="//www.googletagmanager.com/ns.html?id=GTM-MMGGLB" \n\
		height="0" width="0" style="display:none;visibility:hidden"></iframe></noscript> \n\
		<script>(function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({"gtm.start":\n\
		new Date().getTime(),event:"gtm.js"});var f=d.getElementsByTagName(s)[0],\n\
		j=d.createElement(s),dl=l!="dataLayer"?"&l="+l:"";j.async=true;j.src= \n\
		"//www.googletagmanager.com/gtm.js?id="+i+dl;f.parentNode.insertBefore(j,f);\n\
		})(window,document,"script","dataLayer","GTM-PJT9LZ4");</script>'
  );
  // End Google Tag Manager
}

/*----------------------------------------------タグ設置-----------------------------------------*/

function linebreakIfSmallScreen() {
  if ($(window).width() < 640) {
    document.write("<br/>");
  }
}

// 電子發票條碼驗證區塊
(function () {
  // 判斷電子載具的建構式 function
  function JudgeElectronicInvoice() {
    // 作為私有屬性, 不可外部存取修改, 用來判斷電子載具是否正確的條件
    this._term = false;
    this._browser = '';
  }

  /** 
   * 增加該建構式的方法, 使用prototype存取
   * 單純的建構式新增方法或是用閉包也可以
   * 使用prototype的話可以比較不消耗資源並且也好管理各個實例化的方法
   */
  JudgeElectronicInvoice.prototype = {
    /** 
     * 因使用直接覆蓋prototype的方式新增共用方法
     * 所以原本的constructor來源會不見, 為了能夠辨識出建構來源因此設置該constructor屬性
     */
    constructor: JudgeElectronicInvoice,

    // 初始化綁定事件
    init: function () {
      /** 
       * 因整個建構式包在IIFE裡, 所以執行setTimeout非同步操作會導致目前建構式的scope遺失變成全域(window)
       * return IIFE時把目前的scope(this)作引數傳入匿名function內當參數(scope)
       * 內部執行setTimeout時因為要綁定剛剛傳入的scope, 所以使用匿名function作為callback
       */
      if (!(document.getElementById('carrierPhone') && document.getElementById('submitBtn'))) {
        return void(function (scope) {
          setTimeout(function () {
            this.init();
          }.bind(scope), 500);
        })(this);
      }

      /** 
       * 用bind綁定目前實例化的scope以免在事件中callback呼叫時scope被HTML element取代掉
       * addEventListener第三個參數是設定事件要在哪個階段被觸發, 預設為false(冒泡階段), 在這邊設定true(捕獲階段)來提早攔截
       * 所以將click事件綁定在submitBtn元素上, 以便在送出訂單的事件之前先被"捕獲"並觸發
       */
      this.blurHandler = this.blurHandler.bind(this);
      this.submitHandler = this.submitHandler.bind(this);
      document.getElementById('carrierPhone').addEventListener('blur', this.blurHandler);
      document.getElementById('submitBtn').addEventListener('click', this.submitHandler, true);

      // 判斷瀏覽器種類使用對應支援的方法
      this._browser = (function () {
        var test = function (regexp) {
          return regexp.test(window.navigator.userAgent);
        }
        switch (true) {
          case test(/edge/i):
            return "edge";
          case test(/opr/i) && (!!window.opr || !!window.opera):
            return "opera";
          case test(/chrome/i) && !!window.chrome:
            return "chrome";
          case test(/trident/i):
            return "ie";
          case test(/firefox/i):
            return "firefox";
          case test(/safari/i):
            return "safari";
          default:
            return "other";
        }
      })();
    },

    // 電子載具輸入欄位blur時觸發的event hanlder
    blurHandler: function (e) {
      if (window.XMLHttpRequest) {
        // 保留目前實例化的scope
        const SELF = this;
        const HTTP_REQUEST = new XMLHttpRequest();
        const REQUEST_URL = 'https://einvoice-proxy.acs-tpkg.com/BIZAPIVAN/biz';
        var carrierPhone = encodeURIComponent(document.getElementById('carrierPhone').value);
        var params = 'version=1.0&\
              action=bcv&\
              barCode=' + carrierPhone + '&\
              TxID=' + new Date().getTime() + '&\
              appId=EINV1201904277061';
        // ES6模板字符串IE不支援
        // 為了方便閱讀將params字串分行串接, 但字串會有空白因此用replace過濾掉空白字元
        params = params.replace(/\s+/g, '');
        HTTP_REQUEST.open('POST', REQUEST_URL, false);
        HTTP_REQUEST.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
        HTTP_REQUEST.onreadystatechange = function () {
          if (HTTP_REQUEST.readyState === 4 && HTTP_REQUEST.status === 200) {
            var data = JSON.parse(HTTP_REQUEST.responseText);
            // 判斷載具是否正確
            if (data.isExist === 'Y') SELF._term = true
            else {
              document.getElementById('carrierPhone').classList.add('error_field');
              document.getElementById('err_carrierType').innerHTML = '請務必輸入正確: 手機條碼';
              console.log('驗證失敗(手機條碼輸入錯誤)!');
              SELF._term = false;
            }
          } else {
            console.error('請求失敗!');
          }
        };
        try {
          HTTP_REQUEST.send(params);
        } catch (error) {
          console.error(error);
          document.getElementById('carrierPhone').removeEventListener('blur', this.blurHandler);
          document.getElementById('submitBtn').removeEventListener('click', this.submitHandler, true);
          console.error('電子發票認證功能已關閉!');
        }
      }
    },

    // 送出按鈕被點擊時執行的event handler
    submitHandler: function (e) {
      e.preventDefault();
      // 用event本身的屬性target來判斷實際上點了哪個元素, 確認目標來避免元素包元素時的大小差別被誤點擊
      if (e.target.id === 'langSubmitBtnText') {
        var radioChecked = document.getElementById("type_Phone").checked || false;
        // 如果勾選電子載具並且載具錯誤則擋下來跳錯, 反之通過並讓當前事件捕獲及冒泡的傳遞進行下去
        if ((!this._term) && radioChecked) {
          // 使用事件本身的方法 stopPropagation 讓當前事件的捕獲及冒泡的傳遞停止下來
          e.stopPropagation();
          var scrollTarget = document.getElementById('tr_carrierType');

          document.getElementById('carrierPhone').classList.add('error_field');
          document.getElementById('err_carrierType').innerHTML = '請務必輸入正確: 手機條碼';

          // 根據不同的瀏覽器使用相對應支援的方法
          if (this._browser === 'ie' || this._browser === 'edge') {
            scrollTarget.scrollIntoView({
              behavior: 'smooth'
            });
          } else {
            window.scrollTo({
              top: scrollTarget.offsetTop,
              behavior: 'smooth'
            });
          }
        }
      } else {
        return;
      }
    }
  };

  // 實例化建構式, 並執行init方法初始化
  var electronicInvoice = new JudgeElectronicInvoice();
  electronicInvoice.init();
})();